/*	Justin Fiedler
	curve.h

	A class to construct a set of curves given a collection of control points.  Curves are made
	into a vector of track points (tPoints) that conform to the type of curve selected (cardinal
	and bspline) hermite is an option but it doesnt work and is only there for personal enjoyment
	and possibly aesethic value and should otherwise be ignored.  Also track points can be made
	to be arc length parameterized or not.  Life doesnt get much better than that.
*/

#ifndef _C_CURVE_
#define _C_CURVE_

#include "stdio.h"
#include "math.h"

#include "MyVector.h"
#include "CPoint.h"

#include <vector>
#include <iostream>
using namespace std;

class cCurve{
	public:
		float B[16];					//the basis function of the curve (4x4 matrix)
		std::vector<CPoint> cPoints;	//array of control points
	
		/*constructors*/
		cCurve();
		cCurve(std::vector<CPoint> _cPoints);
		
		/*set tension of the curve
		*/
		void setTension(float tension);
		
		/*blending function computation (used to simplify value computation)
		*/
		float compFromMatrix(float u, float p0, float p1, float p2, float p3);
		
		/*value of curve at <u>
		*/
		MyVector getPosition(float u, MyVector& p0, MyVector& p1, MyVector& p2, MyVector& p3);
		
		/*derivative of curve at <u>
		*/
		MyVector getDerivative(float u, MyVector& p0, MyVector& p1, MyVector& p2, MyVector& p3);

		/*add control points to curve
		*/
		void addPoints(std::vector<CPoint> points);
		
		/*removes first control point
		*/
		void popCPoint();
};


#endif