/*	Justin Fiedler
	point.cpp

	A simple point class used to make passing 3d points and vectors around more easily.
*/

#include "point.h"


/*set the point to 3d coordinates
*/
void point::set3d(float _x, float _y, float _z){
	x = _x;
	y = _y;
	z = _z;
}

/*set the point to another point
*/
void point::setp(point _p){
	x = _p.x;
	y = _p.y;
	z = _p.z;
}


/*normalize the vector to magnitude <magnitude>
*/
void point::normalize(float magnitude){
	float sum = sqrt(x*x + y*y + z*z)/magnitude;
	x /= sum;
	y /= sum;
	z /= sum;
}

/*returns the cross product of the two vectors(points)
*/
point point::crossProduct(point _p){
	point c;
	c.set3d(y*_p.z - z*_p.y, z*_p.x - x*_p.z, x*_p.y - y*_p.x);
	return c;
}