/*	Justin Fiedler
	point.h

	A simple point class used to make passing 3d points and vectors around more easily.
*/

#ifndef _POINT_
#define _POINT_

#include <math.h>

class point {
	public:
		//inline point() : x(0), y(0), z(_z) {};
		inline point(float _x=0, float _y=0, float _z=0) 
				:	x(_x), y(_y), z(_z) {};
		float x,y,z;				// position of point
		/*set the point to 3d coordinates
		*/
		void set3d(float _x, float _y, float _z);
		/*set the point to another point
		*/
		void setp(point _p);
		/*normalize the vector to magnitude <magnitude>
		*/
		void normalize(float magnitude=1);
		/*returns the cross product of the two vectors(points)
		*/
		point crossProduct(point _p);
};

#endif
